import 'package:dio/dio.dart';


abstract class IResponse {
  bool iSuccess();

  int iCode();

  String? iMessage();

}


/*

extension Take<R> on Response {
  HttpResponse<R> toHttpResponse<R>() {
    Map<String, dynamic> map = this.data;
    HttpResponse<R> httpResponse = HttpResponse<R>();
    httpResponse.retCode = map["retCode"] ?? -1;
    httpResponse.errorMsg = map["errorMsg"];
    if (httpResponse.iSuccess()) {
      httpResponse.data = JsonConvert.fromJsonAsT<R>(map["data"]);
    }
    return httpResponse;
  }

  HttpResponse<PageData<R>> toPageResponse<R>() {
    Map<String, dynamic> map = this.data;
    HttpResponse<PageData<R>> httpResponse = HttpResponse<PageData<R>>();
    httpResponse.retCode = map["retCode"] ?? -1;
    httpResponse.errorMsg = map["errorMsg"];
    if (!httpResponse.iSuccess()) return httpResponse;

    var pageMap = map["data"];
    PageData<R> pageData = PageData<R>();
    pageData.total = pageMap["total"];
    pageData.curPage = pageMap["curPage"];
    pageData.offset = pageMap["offset"];
    pageData.over = pageMap["over"];
    pageData.pageCount = pageMap["pageCount"];
    pageData.size = pageMap["size"];
    R.toString();
    pageData.datas = JsonConvert.fromJsonAsT<List<R>>(pageMap["data"]);
    httpResponse.data = pageData;
    return httpResponse;
  }

  R take<R>({bool errorShow = true}) {
    HttpResponse<R> httpResponse = toHttpResponse<R>();
    if (!httpResponse.iSuccess()) {
      if (errorShow && httpResponse.errorMsg != null) {
        Toast.show(httpResponse.errorMsg);
      }
      throw new Exception(httpResponse.errorMsg);
    }
    return httpResponse.data;
  }

  PageData<R> takePage<R>({bool errorShow = true}) {
    HttpResponse<PageData<R>> httpResponse = toPageResponse<R>();
    if (!httpResponse.iSuccess()) {
      if (errorShow && httpResponse.errorMsg != null) {
        Toast.show(httpResponse.errorMsg);
      }
      throw new Exception(httpResponse.errorMsg);
    }
    return httpResponse.data;
  }
}

class HttpResponse<T> extends IResponse {
  int retCode;
  T data;
  String errorMsg;

  @override
  int iCode() => retCode;

  @override
  String iMessage() => errorMsg;

  @override
  bool iSuccess() => retCode == 0;
}

class PageData<T> {
  List<T> datas;
}
*/

/*
class Bo {
  static Future<dynamic> login(String password, {CancelToken cancelToken}) async {
  Map<String, dynamic> map = {"password": password}
    var response = await HTTPManager.getInstance().post("adm/login", cancelToken: cancelToken, data: new FormData.fromMap(map));
    return response.take<dynamic>();
  }
}

* */